// 5648-C84, 5648-C83, (C) Copyright IBM Corporation, 1997, 2000
// All rights reserved. Licensed Materials Property of IBM
// Note to US Government users: Documentation related to restricted rights
// Use, duplication or disclosure is subject to restrictions set forth in GSA ADP Schedule with IBM Corp.
// This page may contain other proprietary notices and copyright information, the terms of which must be observed and followed.
//
// This program may be used, executed, copied, modified and distributed
// without royalty for the purpose of developing, using,
// marketing, or distributing.

/**
*
* Description - PollUpdateBean
*/
package WebSphereSamples.Poll;
// Imports
import com.ibm.db.*;
import com.ibm.webtools.runtime.*;
import java.io.*;
import java.math.*;

// Imports for App Server V3 connection pooling
import javax.sql.DataSource;
import com.ibm.ejs.dbm.jdbcext.*;
import java.sql.*;
import java.util.*;
import com.ibm.websphere.advanced.cm.factory.*;
import javax.naming.*;

public class PollUpdateBean extends java.lang.Object
{
   /**
   * Instance variable for noVote property
   */
   protected java.lang.String noVote = null;

   /**
   * Instance variable for pollId property
   */
   protected java.lang.String pollId = null;

   /**
   * Instance variable for URL property
   */
   protected java.lang.String URL = null;

   /**
   * Instance variable for driver property
   */
   protected java.lang.String driver = null;

   /**
   * Instance variable for yesVote property
   */
   protected java.lang.String yesVote = null;

   /**
   * Variable to hold DataSource
   */
   protected DataSource ds = null;

   /**
   * Variable to hold connection
   */
   protected Connection connection = null;

   /*****************************************************************************
   * Get method for the noVote property
   * @return the value of the noVote property
   */
   public java.lang.String getNoVote()
   {
      return noVote;
   }

   /*****************************************************************************
   * Set method for the noVote property
   * @param value the new value for the noVote property
   */
   public void setNoVote(java.lang.String value)
   {
      this.noVote = value;
   }

   /*****************************************************************************
   * Get method for the pollId property
   * @return the value of the pollId property
   */
   public java.lang.String getPollId()
   {
      return pollId;
   }

   /*****************************************************************************
   * Set method for the pollId property
   * @param value the new value for the pollId property
   */
   public void setPollId(java.lang.String value)
   {
      this.pollId = value;
   }

   /*****************************************************************************
   * Get method for the URL property
   * @return the value of the URL property
   */
   public java.lang.String getURL()
   {
      return URL;
   }

   /*****************************************************************************
   * Set method for the URL property
   * @param value the new value for the URL property
   */
   public void setURL(java.lang.String value)
   {
      this.URL = value;
   }

   /*****************************************************************************
   * Get method for the driver property
   * @return the value of the driver property
   */
   public java.lang.String getDriver()
   {
      return driver;
   }

   /*****************************************************************************
   * Set method for the driver property
   * @param value the new value for the driver property
   */
   public void setDriver(java.lang.String value)
   {
      this.driver = value;
   }

   /*****************************************************************************
   * Get method for the yesVote property
   * @return the value of the yesVote property
   */
   public java.lang.String getYesVote()
   {
      return yesVote;
   }

   /*****************************************************************************
   * Set method for the yesVote property
   * @param value the new value for the yesVote property
   */
   public void setYesVote(java.lang.String value)
   {
      this.yesVote = value;
   }

   /*****************************************************************************
   * execute action method
   * @exception java.io.IOException
   * @exception java.lang.Exception
   */
   public void execute()
   throws java.io.IOException, java.lang.Exception
   {
      connection = getPooledConnection(URL, driver);
      java.sql.Statement stmt = connection.createStatement();
      stmt.executeUpdate("UPDATE POLL SET YES_ANS = " + yesVote + ", NO_ANS = " + noVote + " WHERE POLL_ID = " + pollId);
      stmt.close();
      connection.close();
   }

   /*****************************************************************************
   * Attempts to get a connection from a App Server V3 connection pool.
   *
   * @param URL Contains the database url for the connection
   * @param driver Contains the JDBC driver name to use for the connection
   * @return a pooled JDBC connection or null
   */
   protected Connection getPooledConnection(String URL, String driver)
   {
      Connection conn = null;

      try
      {
         // create parameter list to access naming system
         Hashtable parms = new Hashtable();
         parms.put(Context.INITIAL_CONTEXT_FACTORY, "com.ibm.ejs.ns.jndi.CNInitialContextFactory");
         // access naming system
         Context context = new InitialContext(parms);
         // get DataSource factory object from naming system
         ds = (DataSource)context.lookup("jdbc/anyname");
         conn = ds.getConnection("anyuser", "anypassword");
      }
      catch (Throwable t)
      {
         // DataSource not found. Try to construct a new DataSource.
         // It will be used by all subsequent IDB samples.
         try
         {
            com.ibm.websphere.advanced.cm.factory.DataSourceFactory factory = new com.ibm.websphere.advanced.cm.factory.DataSourceFactory();
            Attributes attrs = new Attributes();
            attrs.name   = "anyname";
            attrs.driver = driver;
            attrs.url    = URL;
            attrs.max = 30;
            ds = factory.createJDBCDataSource(attrs);
            conn = ds.getConnection("anyuser", "anypassword");
            try
            {
               factory.bindDataSource(ds);
            }
            catch (javax.naming.NamingException namingExc)
            {
            }
         }
         catch (Throwable t1)
         {
            t1.printStackTrace();
         }
      }
      return conn;
   }
}
