// 5648-C84, 5648-C83, (C) Copyright IBM Corporation, 1997, 2000
// All rights reserved. Licensed Materials Property of IBM
// Note to US Government users: Documentation related to restricted rights
// Use, duplication or disclosure is subject to restrictions set forth in GSA ADP Schedule with IBM Corp.
// This page may contain other proprietary notices and copyright information, the terms of which must be observed and followed.
//
// This program may be used, executed, copied, modified and distributed
// without royalty for the purpose of developing, using,
// marketing, or distributing.

/**
* 
* Description - InsertPreferences
*/ 
package WebSphereSamples.YourCo.Employee;

// Imports
import com.ibm.servlet.*;
import com.ibm.webtools.runtime.*;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

// Imports for beans used by this servlet
import WebSphereSamples.YourCo.Employee.InsertPreferencesDBBean;
import WebSphereSamples.YourCo.Employee.DeletePreferencesDBBean;
import WebSphereSamples.YourCo.Employee.UpdateUserDBBean;

public class InsertPreferences extends com.ibm.webtools.runtime.StudioPervasiveServlet implements Serializable
{

   /*****************************************************************************
   * Process incoming requests for information
   * 
   * @param request Object that encapsulates the request to the servlet
   * @param response Object that encapsulates the response from the servlet
   */
   public void performTask(HttpServletRequest request, HttpServletResponse response)
   {
      try
      {

         HttpSession session = request.getSession(true);
         WebSphereSamples.YourCo.Login.SessionBean sessionBean = null;
         sessionBean = (WebSphereSamples.YourCo.Login.SessionBean) session.getValue("sessionBean");

         if (sessionBean != null)
         {

            // instantiate the beans and store them so they can be accessed by the called page
            WebSphereSamples.YourCo.Employee.DeletePreferencesDBBean deletePreferencesDBBean = null;
            deletePreferencesDBBean = (WebSphereSamples.YourCo.Employee.DeletePreferencesDBBean) java.beans.Beans.instantiate(getClass().getClassLoader(), "WebSphereSamples.YourCo.Employee.DeletePreferencesDBBean");

            // instantiate the beans and store them so they can be accessed by the called page
            WebSphereSamples.YourCo.Employee.InsertPreferencesDBBean insertPreferencesDBBean = null;
            insertPreferencesDBBean = (WebSphereSamples.YourCo.Employee.InsertPreferencesDBBean) java.beans.Beans.instantiate(getClass().getClassLoader(), "WebSphereSamples.YourCo.Employee.InsertPreferencesDBBean");

            // instantiate the beans and store them so they can be accessed by the called page
            WebSphereSamples.YourCo.Employee.UpdateUserDBBean updateUserDBBean = null;
            updateUserDBBean = (WebSphereSamples.YourCo.Employee.UpdateUserDBBean) java.beans.Beans.instantiate(getClass().getClassLoader(), "WebSphereSamples.YourCo.Employee.UpdateUserDBBean");

            setRequestAttribute("insertPreferencesDBBean", insertPreferencesDBBean, request);
            setRequestAttribute("updateUserDBBean", updateUserDBBean, request);

            String URL    = (String)getServletConfig().getServletContext().getAttribute("URL");
            String driver = getParameter(request, "driver", true, true, true, null);

            String empno = sessionBean.getEmpno();

            Enumeration paramEnum = null;
            String link = null;

            // Initialize the bean URL property from the parameters
            deletePreferencesDBBean.setURL(URL);

            // Initialize the bean driver property from the parameters
            deletePreferencesDBBean.setDriver(driver);

            // Initialize the bean empno property from the parameters
            deletePreferencesDBBean.setEmpno(empno);

            // Call the execute action on the bean.
            deletePreferencesDBBean.execute();      



            // Initialize the bean URL property from the parameters
            insertPreferencesDBBean.setURL(URL);

            // Initialize the bean driver property from the parameters
            insertPreferencesDBBean.setDriver(driver);

            // Initialize the bean empno property from the parameters
            insertPreferencesDBBean.setEmpno(empno);



            // Initialize the bean URL property from the parameters
            updateUserDBBean.setURL(URL);

            // Initialize the bean driver property from the parameters
            updateUserDBBean.setDriver(driver);

            // Initialize the bean empno property from the parameters
            updateUserDBBean.setEmpno(empno);


            paramEnum = request.getParameterNames();

            while ( paramEnum.hasMoreElements() )
            {
               link = (String)paramEnum.nextElement();

               if ( link.equals("stock") )
               {
                  String stock = getParameter(request, "stock", true, true, true, null);
                  updateUserDBBean.setStock( stock );
                  sessionBean.setStock( Integer.parseInt(stock) );
               }
               else if ( link.equals("quote") )
               {
                  String quote = getParameter(request, "quote", true, true, true, null);
                  updateUserDBBean.setQuote( quote );
                  sessionBean.setQuote( Integer.parseInt(quote) );
               }
               else if ( request.getParameter(link) != null)
               {
                  // Initialize the bean link property from the parameters
                  insertPreferencesDBBean.setLink( link );

                  // Call the execute action on the bean.
                  insertPreferencesDBBean.execute();
               }
            }

            updateUserDBBean.execute();

            // Call the output page. If the output page is not passed
            // as part of the URL, the default page is called.
            callPage(getPageNameFromRequest(request), request, response);

         }
         else
         {
            throw new Exception("No session bean - this user has not logged in yet");
         }
      }

      catch (Throwable theException)
      {
         handleError(request, response, theException);
      }
   }
}

