// 5648-C84, 5648-C83, (C) Copyright IBM Corporation, 1997, 2000
// All rights reserved. Licensed Materials Property of IBM
// Note to US Government users: Documentation related to restricted rights
// Use, duplication or disclosure is subject to restrictions set forth in GSA ADP Schedule with IBM Corp.
// This page may contain other proprietary notices and copyright information, the terms of which must be observed and followed.
//
// This program may be used, executed, copied, modified and distributed
// without royalty for the purpose of developing, using,
// marketing, or distributing.

/**
* 
* Description - AddJob
*/ 
package WebSphereSamples.YourCo.Jobs;

// Imports
import com.ibm.servlet.*;
import com.ibm.webtools.runtime.*;
import java.io.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;

// Imports for beans used by this servlet
import WebSphereSamples.YourCo.Jobs.AddJobDBBean;

public class AddJob extends com.ibm.webtools.runtime.StudioPervasiveServlet implements Serializable
{

   /*****************************************************************************
   * Process incoming requests for information
   * 
   * @param request Object that encapsulates the request to the servlet
   * @param response Object that encapsulates the response from the servlet
   */
   public void performTask(HttpServletRequest request, HttpServletResponse response)
   {
      try
      {

         // instantiate the beans and store them so they can be accessed by the called page
         WebSphereSamples.YourCo.Jobs.AddJobDBBean addJobDBBean = null;
         addJobDBBean = (WebSphereSamples.YourCo.Jobs.AddJobDBBean) java.beans.Beans.instantiate(getClass().getClassLoader(), "WebSphereSamples.YourCo.Jobs.AddJobDBBean");

         setRequestAttribute("addJobDBBean", addJobDBBean, request);

         // Initialize the bean URL property from the webapp URL attribute
         addJobDBBean.setURL((String)getServletConfig().getServletContext().getAttribute("URL"));

         // Initialize the bean driver property from the parameters
         addJobDBBean.setDriver(getParameter(request, "driver", true, true, false, null));

         //	Initialize the bean date property from the current date
         java.text.SimpleDateFormat formatter = new java.text.SimpleDateFormat("yyyy-MM-dd");
         addJobDBBean.setDate(formatter.format(new java.util.Date()));

         // Initialize the bean position property from the parameters
         addJobDBBean.setPosition(getParameter(request, "position", true, true, false, null));

         // Initialize the bean level property from the parameters
         addJobDBBean.setLevel(getParameter(request, "level", true, true, false, null));

         // Initialize the bean description property from the parameters
         addJobDBBean.setDescription(getParameter(request, "description", true, true, false, null));

         // Initialize the bean dept property from the parameters
         addJobDBBean.setDept(getParameter(request, "dept", true, true, false, null));

         // Call the execute action on the bean.
         addJobDBBean.execute();

         // Call the output page. If the output page is not passed
         // as part of the URL, the default page is called.
         callPage(getPageNameFromRequest(request), request, response);

      }

      catch (Throwable theException)
      {
         handleError(request, response, theException);
      }
   }
}
