// 5648-C84, 5648-C83, (C) Copyright IBM Corporation, 1997, 2000
// All rights reserved. Licensed Materials Property of IBM
// Note to US Government users: Documentation related to restricted rights
// Use, duplication or disclosure is subject to restrictions set forth in GSA ADP Schedule with IBM Corp.
// This page may contain other proprietary notices and copyright information, the terms of which must be observed and followed.
//
// This program may be used, executed, copied, modified and distributed
// without royalty for the purpose of developing, using,
// marketing, or distributing.

/**
*
* Description - LoginDBBean
*/
package WebSphereSamples.YourCo.Login;
// Imports
import com.ibm.db.*;
import com.ibm.webtools.runtime.*;
import java.io.*;
import java.math.*;

// Imports for App Server V3 connection pooling
import javax.sql.DataSource;
import com.ibm.ejs.dbm.jdbcext.*;
import java.sql.*;
import java.util.*;
import com.ibm.websphere.advanced.cm.factory.*;
import javax.naming.*;

public class LoginDBBean extends java.lang.Object
{
   /**
   * Instance variable for driver property
   */
   protected java.lang.String driver = null;

   /**
   * Instance variable for passwd property
   */
   protected java.lang.String passwd = null;

   /**
   * Instance variable for URL property
   */
   protected java.lang.String URL = null;

   /**
   * Instance variable for username property
   */
   protected java.lang.String username = null;

   /**
   * Variable to hold DataSource
   */
   protected DataSource ds = null;

   /**
   * Variable to hold connection
   */
   protected Connection connection = null;

   /**
   * Vector to hold USER_EMPNO property values
   */
   protected Vector USER_EMPNOVector = new Vector();

   /**
   * Vector to hold EMPLOYEE_FIRSTNME property values
   */
   protected Vector EMPLOYEE_FIRSTNMEVector = new Vector();

   /**
   * Vector to hold EMPLOYEE_LASTNAME property values
   */
   protected Vector EMPLOYEE_LASTNAMEVector = new Vector();

   /**
   * Vector to hold USER_QUOTE property values
   */
   protected Vector USER_QUOTEVector = new Vector();

   /**
   * Vector to hold USER_STOCK property values
   */
   protected Vector USER_STOCKVector = new Vector();

   /**
   * Vector to hold USER_MANAGER property values
   */
   protected Vector USER_MANAGERVector = new Vector();

   /*****************************************************************************
   * Get method for the indexed USER_EMPNO property
   * @param index The 0 based index of the desired value
   * @return the value of the USER_EMPNO property at the specified index
   */
   public java.lang.String getUSER_EMPNO(int index)
   throws java.lang.ArrayIndexOutOfBoundsException
   {
      return (String)USER_EMPNOVector.elementAt(index);
   }

   /*****************************************************************************
   * Get method for the indexed EMPLOYEE_FIRSTNME property
   * @param index The 0 based index of the desired value
   * @return the value of the EMPLOYEE_FIRSTNME property at the specified index
   */
   public java.lang.String getEMPLOYEE_FIRSTNME(int index)
   throws java.lang.ArrayIndexOutOfBoundsException
   {
      return (String)EMPLOYEE_FIRSTNMEVector.elementAt(index);
   }

   /*****************************************************************************
   * Get method for the indexed EMPLOYEE_LASTNAME property
   * @param index The 0 based index of the desired value
   * @return the value of the EMPLOYEE_LASTNAME property at the specified index
   */
   public java.lang.String getEMPLOYEE_LASTNAME(int index)
   throws java.lang.ArrayIndexOutOfBoundsException
   {
      return (String)EMPLOYEE_LASTNAMEVector.elementAt(index);
   }

   /*****************************************************************************
   * Get method for the indexed USER_QUOTE property
   * @param index The 0 based index of the desired value
   * @return the value of the USER_QUOTE property at the specified index
   */
   public java.lang.Integer getUSER_QUOTE(int index)
   throws java.lang.ArrayIndexOutOfBoundsException
   {
      return new Integer((String)USER_QUOTEVector.elementAt(index));
   }

   /*****************************************************************************
   * Get method for the indexed USER_STOCK property
   * @param index The 0 based index of the desired value
   * @return the value of the USER_STOCK property at the specified index
   */
   public java.lang.Integer getUSER_STOCK(int index)
   throws java.lang.ArrayIndexOutOfBoundsException
   {
      return new Integer((String)USER_STOCKVector.elementAt(index));
   }

   /*****************************************************************************
   * Get method for the indexed USER_MANAGER property
   * @param index The 0 based index of the desired value
   * @return the value of the USER_MANAGER property at the specified index
   */
   public java.lang.Integer getUSER_MANAGER(int index)
   throws java.lang.ArrayIndexOutOfBoundsException
   {
      return new Integer((String)USER_MANAGERVector.elementAt(index));
   }

   /*****************************************************************************
   * Get method for the driver property
   * @return the value of the driver property
   */
   public java.lang.String getDriver()
   {
      return driver;
   }

   /*****************************************************************************
   * Set method for the driver property
   * @param value the new value for the driver property
   */
   public void setDriver(java.lang.String value)
   {
      this.driver = value;
   }

   /*****************************************************************************
   * Set method for the passwd property
   * @param value the new value for the passwd property
   */
   public void setPassword(java.lang.String value)
   {
      this.passwd = value;
   }

   /*****************************************************************************
   * Get method for the URL property
   * @return the value of the URL property
   */
   public java.lang.String getURL()
   {
      return URL;
   }

   /*****************************************************************************
   * Set method for the URL property
   * @param value the new value for the URL property
   */
   public void setURL(java.lang.String value)
   {
      this.URL = value;
   }

   /*****************************************************************************
   * Get method for the username property
   * @return the value of the username property
   */
   public java.lang.String getUsername()
   {
      return username;
   }

   /*****************************************************************************
   * Set method for the username property
   * @param value the new value for the username property
   */
   public void setUsername(java.lang.String value)
   {
      this.username = value;
   }

   /*****************************************************************************
   * execute action method
   * @exception java.io.IOException
   * @exception java.lang.Exception
   */
   public void execute()
   throws java.io.IOException, java.lang.Exception
   {
      // Odd behavior in InstantDB causes an SQL error with a passwd of "manager" so resort
      // to a kludge.  We want to use a passwd of "manager" in order to be consistent
      // with the non-InstantDB versions of the samples.  Therefore, make the real password
      // "management" (exact case) and translate an input of "manager" (exact case)
      // to "management" (exact case).  The translated passwd is used in the query.  If the
      // user input is mixed case "manager" or "management" then the method returns, so the
      // result Vectors are empty - just like the results for an invalid password.  In all
      // other cases, the user supplied password is passed on to the SQL SELECT.
      if (passwd.equals("manager"))                     // exact case
      {
         passwd = "management";                         // translate
      }
      else if (passwd.equalsIgnoreCase("manager"))      // catch all other cases
      {
         return;
      }
      else if (passwd.equalsIgnoreCase("management"))   // catch all other cases
      {
         return;
      }
      connection = getPooledConnection(URL, driver);
      java.sql.Statement stmt = connection.createStatement();
      ResultSet rs = stmt.executeQuery( "SELECT THEUSER.EMPNO, EMPLOYEE.FIRSTNME, EMPLOYEE.LASTNAME, " +
                                        "THEUSER.THEQUOTE, THEUSER.STOCK, THEUSER.MANAGER " +
                                        "FROM EMPLOYEE, THEUSER " +
                                        "WHERE ( ( EMPLOYEE.EMPNO = THEUSER.EMPNO ) " +
                                        "AND ( ( THEUSER.PASSWORD = '" + insertQuoteEscape(passwd) + "' ) " +
                                        "AND ( THEUSER.USERNAME = '" + insertQuoteEscape(username) + "' ) ) )");
      // There will usually be multiple rows.
      while (rs.next())
      {
         USER_EMPNOVector.addElement(rs.getString(1));
         EMPLOYEE_FIRSTNMEVector.addElement(rs.getString(2));
         EMPLOYEE_LASTNAMEVector.addElement(rs.getString(3));
         USER_QUOTEVector.addElement(rs.getString(4));
         USER_STOCKVector.addElement(rs.getString(5));
         USER_MANAGERVector.addElement(rs.getString(6));
      }
      USER_EMPNOVector.trimToSize();
      EMPLOYEE_FIRSTNMEVector.trimToSize();
      EMPLOYEE_LASTNAMEVector.trimToSize();
      USER_QUOTEVector.trimToSize();
      USER_STOCKVector.trimToSize();
      USER_MANAGERVector.trimToSize();
      rs.close();
      stmt.close();
      connection.close();
   }

   /*****************************************************************************
   * Attempts to get a connection from a App Server V3 connection pool.
   *
   * @param URL Contains the database url for the connection
   * @param driver Contains the JDBC driver name to use for the connection
   * @return a pooled JDBC connection or null
   */
   protected Connection getPooledConnection(String URL, String driver)
   {
      Connection conn = null;

      try
      {
         // create parameter list to access naming system
         Hashtable parms = new Hashtable();
         parms.put(Context.INITIAL_CONTEXT_FACTORY, "com.ibm.ejs.ns.jndi.CNInitialContextFactory");
         // access naming system
         Context context = new InitialContext(parms);
         // get DataSource factory object from naming system
         ds = (DataSource)context.lookup("jdbc/anyname");
         conn = ds.getConnection("anyuser", "anypassword");
      }
      catch (Throwable t)
      {
         // DataSource not found. Try to construct a new DataSource.
         // It will be used by all subsequent IDB samples.
         try
         {
            com.ibm.websphere.advanced.cm.factory.DataSourceFactory factory = new com.ibm.websphere.advanced.cm.factory.DataSourceFactory();
            Attributes attrs = new Attributes();
            attrs.name   = "anyname";
            attrs.driver = driver;
            attrs.url    = URL;
            attrs.max = 30;
            ds = factory.createJDBCDataSource(attrs);
            conn = ds.getConnection("anyuser", "anypassword");
            try
            {
               factory.bindDataSource(ds);
            }
            catch (javax.naming.NamingException namingExc)
            {
            }
         }
         catch (Throwable t1)
         {
            t1.printStackTrace();
         }
      }
      return conn;
   }

   /*****************************************************************************
   * InstantDB fails with SQL text string containing single quote ' - needs escaped
   * single quote \' to work properly.
   * Let's meet
   * ...converted to...
   * Let\'s meet
   * Also, backslash \ needs to be escaped.
   * C:\wombat
   * ...converted to...
   * C:\\wombat
   * Must handle \ and ' combination.
   * O\'DONNEL
   ...converted to...
   * O\\\'DONNEL
   *
   * @param String possibly containing a single quote
   * @return String with single quote escaped
   */
   private String insertQuoteEscape(String input)
   {
      // Turns O\'DONNEL to O\\'DONNEL (escape the \)
      // Escape the \ first, or else we would mistakenly
      // escape the \ added to escape the '.
      StringBuffer buffer = new StringBuffer(input.length());
      char testChar;
      for (int i = 0; i < input.length(); i++)
      {
         testChar = input.charAt(i);
         if (testChar == '\\')
         {
            buffer.append('\\');
         }
         buffer.append(testChar);
      }
      String input1 = buffer.toString();
      // Turns O\\'DONNEL to O\\\'DONNEL (escape the ')
      StringBuffer buffer1 = new StringBuffer(input1.length());
      for (int j = 0; j < input1.length(); j++)
      {
         testChar = input1.charAt(j);
         if (testChar == '\'')
         {
            buffer1.append('\\');
         }
         buffer1.append(testChar);
      }
      return buffer1.toString();
   }
}







