// 5648-C84, 5648-C83, (C) Copyright IBM Corporation, 1997, 2000
// All rights reserved. Licensed Materials Property of IBM
// Note to US Government users: Documentation related to restricted rights
// Use, duplication or disclosure is subject to restrictions set forth in GSA ADP Schedule with IBM Corp.
// This page may contain other proprietary notices and copyright information, the terms of which must be observed and followed.
//
// This program may be used, executed, copied, modified and distributed
// without royalty for the purpose of developing, using,
// marketing, or distributing.

/**
* 
* Description - SelectNames
*/ 
package WebSphereSamples.YourCo.Search;

// Imports
import com.ibm.servlet.*;
import com.ibm.webtools.runtime.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

// Imports for beans used by this servlet
import WebSphereSamples.YourCo.Search.SelectNamesDBBean;
import WebSphereSamples.YourCo.Search.SelectJobsDBBean;
import WebSphereSamples.YourCo.Search.SelectDeptsDBBean;

public class SelectNames extends com.ibm.webtools.runtime.StudioPervasiveServlet implements Serializable
{
   /*****************************************************************************
   * Process incoming requests for information
   * 
   * @param request Object that encapsulates the request to the servlet
   * @param response Object that encapsulates the response from the servlet
   */
   public void performTask(HttpServletRequest request, HttpServletResponse response)
   {
      try
      {

         // instantiate the beans and store them so they can be accessed by the called page
         WebSphereSamples.YourCo.Search.SelectNamesDBBean selectNamesDBBean = null;
         selectNamesDBBean = (WebSphereSamples.YourCo.Search.SelectNamesDBBean) java.beans.Beans.instantiate(getClass().getClassLoader(), "WebSphereSamples.YourCo.Search.SelectNamesDBBean");

         WebSphereSamples.YourCo.Search.SelectJobsDBBean selectJobsDBBean = null;
         selectJobsDBBean = (WebSphereSamples.YourCo.Search.SelectJobsDBBean) java.beans.Beans.instantiate(getClass().getClassLoader(), "WebSphereSamples.YourCo.Search.SelectJobsDBBean");

         WebSphereSamples.YourCo.Search.SelectDeptsDBBean selectDeptsDBBean = null;
         selectDeptsDBBean = (WebSphereSamples.YourCo.Search.SelectDeptsDBBean) java.beans.Beans.instantiate(getClass().getClassLoader(), "WebSphereSamples.YourCo.Search.SelectDeptsDBBean");

         setRequestAttribute("selectNamesDBBean", selectNamesDBBean, request);
         setRequestAttribute("selectJobsDBBean", selectJobsDBBean, request);
         setRequestAttribute("selectDeptsDBBean", selectDeptsDBBean, request);

         // Do work for selectNamesDBBean

         // Initialize the bean URL property from the webapp URL attribute
         selectNamesDBBean.setURL((String)getServletConfig().getServletContext().getAttribute("URL"));

         // Initialize the bean driver property from the parameters
         selectNamesDBBean.setDriver(getParameter(request, "driver", true, true, false, null));

         // Call the execute action on the bean.
         selectNamesDBBean.execute();


         // Do work for selectJobsDBBean

         // Initialize the bean URL property from the webapp URL attribute
         selectJobsDBBean.setURL((String)getServletConfig().getServletContext().getAttribute("URL"));

         // Initialize the bean driver property from the parameters
         selectJobsDBBean.setDriver(getParameter(request, "driver", true, true, false, null));

         // Call the execute action on the bean.
         selectJobsDBBean.execute();


         // Do work for selectDeptsDBBean

         // Initialize the bean URL property from the webapp URL attribute
         selectDeptsDBBean.setURL((String)getServletConfig().getServletContext().getAttribute("URL"));

         // Initialize the bean driver property from the parameters
         selectDeptsDBBean.setDriver(getParameter(request, "driver", true, true, false, null));

         // Call the execute action on the bean.
         selectDeptsDBBean.execute();

         // Call the output page. If the output page is not passed
         // as part of the URL, the default page is called.
         callPage(getPageNameFromRequest(request), request, response);

      }

      // handle com.ibm.webtools.runtime.NoDataException
      catch (com.ibm.webtools.runtime.NoDataException theException)
      {
         try
         {
            callPageNamed(getParameter(request, "com.ibm.webtools.runtime.NoDataException", true, true, false, "com.ibm.webtools.runtime.NoDataException"), request, response);
         }
         catch (Throwable e)
         {
            handleError(request, response, theException);
         }
      }

      catch (Throwable theException)
      {
         handleError(request, response, theException);
      }
   }
}
