// 5648-C84, 5648-C83, (C) Copyright IBM Corporation, 1997, 2000
// All rights reserved. Licensed Materials Property of IBM
// Note to US Government users: Documentation related to restricted rights
// Use, duplication or disclosure is subject to restrictions set forth in GSA ADP Schedule with IBM Corp.
// This page may contain other proprietary notices and copyright information, the terms of which must be observed and followed.
//
// This program may be used, executed, copied, modified and distributed
// without royalty for the purpose of developing, using,
// marketing, or distributing.

/**
* This file was generated by IBM WebSphere Studio Version 3.5
* g:\WebSphere\Studio\BIN\GenerationStyleSheets\V3.5\JSP1.0\ServletModel\JavaServlet.xsl stylesheet was used to generate this file.
*
* 
* Descriptioon - ExpiringHTMLServlet
*/ 
package WebSphereSamples.ExpHTMLServlet;

/**
* This sample demonstrates the use of expiring HTML (JSP) pages.
*/

public class ExpiringHTMLServlet extends com.ibm.webtools.runtime.StudioPervasiveServlet implements java.io.Serializable
{

   /*****************************************************************************
   * Process incoming requests for information
   * 
   * @param request Object that encapsulates the request to the servlet
   * @param response Object that encapsulates the response from the servlet
   */
   public void performTask(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response)
   {
      try
      {
         int year = java.lang.Integer.valueOf(getParameter(request, "year", true, true, true, null)).intValue();
         int month = java.lang.Integer.valueOf(getParameter(request, "month", true, true, true, null)).intValue();
         int day = java.lang.Integer.valueOf(getParameter(request, "day", true, true, true, null)).intValue();
         int hour = java.lang.Integer.valueOf(getParameter(request, "hour", true, true, true, null)).intValue();
         int minute = java.lang.Integer.valueOf(getParameter(request, "minute", true, true, true, null)).intValue();

         // The following lines prevent servlet output from being cached by proxies and browsers.  Remove them if you want to allow caching.
         response.setHeader("Cache-Control", "no-Cache");
         response.setHeader("Pragma", "No-cache");
         response.setDateHeader("Expires", 0);

         // Get the current time
         java.util.Calendar currentTime = java.util.Calendar.getInstance();

         // Compute the expiration time. Subtract 1 from the month
         // because GregorianCalendars have zero-based months.
         java.util.Calendar expireTime = new java.util.GregorianCalendar(year, month-1, day, hour, minute);

         if (currentTime.before(expireTime))
         {
            // Call the output page from the parameter.
            callPageNamed(getParameter(request, "beforeDatePage", true, true, false, "beforeDatePage"), request, response);
         }
         else
         {
            // Call the output page from the parameter.
            callPageNamed(getParameter(request, "afterDatePage", true, true, false, "afterDatePage"), request, response);
         }

      }
      catch (Exception theException)
      {
         handleError(request, response, theException);
      }
   }
}
