// 5648-C84, 5648-C83, (C) Copyright IBM Corporation, 1997, 2000
// All rights reserved. Licensed Materials Property of IBM
// Note to US Government users: Documentation related to restricted rights
// Use, duplication or disclosure is subject to restrictions set forth in GSA ADP Schedule with IBM Corp.
// This page may contain other proprietary notices and copyright information, the terms of which must be observed and followed.
//
// This program may be used, executed, copied, modified and distributed
// without royalty for the purpose of developing, using,
// marketing, or distributing.

/**
* This file was generated by IBM WebSphere Studio Version 3.5
* g:\WebSphere\Studio\BIN\GenerationStyleSheets\V3.5\JSP1.0\ServletModel\JavaServlet.xsl stylesheet was used to generate this file.
*
* 
* Description - PollServlet
*/ 
package WebSphereSamples.Poll;

// Imports
import com.ibm.servlet.*;
import com.ibm.webtools.runtime.*;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

// Imports for beans used by this servlet

import WebSphereSamples.Poll.PollQueryDBBean;
import WebSphereSamples.Poll.PollUpdateBean;


public class PollServlet extends com.ibm.webtools.runtime.StudioPervasiveServlet implements Serializable
{

/*  ****************************************************************************
  * Process incoming requests for information
  * 
  * @param request Object that encapsulates the request to the servlet
  * @param response Object that encapsulates the response from the servlet
  */
  public void performTask(HttpServletRequest request, HttpServletResponse response)
  {
    try 
    {

//       initialization parameters
      String userID = getParameter(request, "userID", true, true, true, null);
      String password = getParameter(request, "password", true, true, true, null);
      String URL = getParameter(request, "URL", true, true, true, null);
      String driver = getParameter(request, "driver", true, true, true, null);
      String dataSourceName = getParameter(request, "dataSourceName", true, true, true, null);

//       form input parameters
      String pollId = getParameter(request, "pollId", true, true, true, null);
      String vote = getParameter(request, "vote", true, true, true, null);

//       to be fetched from database as ppollQueryDBBean properties
      int yesVote = 0;
      int noVote = 0;

//       instantiate the beans and store them so they can be accessed by the called page
      WebSphereSamples.Poll.PollQueryDBBean pollQueryDBBean = new WebSphereSamples.Poll.PollQueryDBBean();

      WebSphereSamples.Poll.PollUpdateBean pollUpdateBean = new WebSphereSamples.Poll.PollUpdateBean();
            
      setRequestAttribute("pollQueryDBBean", pollQueryDBBean, request);
      setRequestAttribute("pollUpdateBean", pollUpdateBean, request);      


//       Initialize the bean userID property from the parameters
      pollQueryDBBean.setUserID( userID );

//       Initialize the bean password property from the parameters
      pollQueryDBBean.setPassword( password );
      
//       Initialize the bean URL property from the parameters
      pollQueryDBBean.setURL( URL );

//       Initialize the bean driver property from the parameters
      pollQueryDBBean.setDriver( driver );

//       Initialize the bean datasource property from the parameters
      pollQueryDBBean.setDataSourceName( dataSourceName );

//       Specify which poll question in the database is being answered
      pollQueryDBBean.setPollId( pollId );
      
//       call the execute action on the bean
      pollQueryDBBean.execute();

//       Get the number of yes and no votes from the database using the ppollQueryDBBean
      yesVote = pollQueryDBBean.getYES_ANS(0).intValue();
      noVote = pollQueryDBBean.getNO_ANS(0).intValue();
  
      if (vote.equals("yes"))
      {
        yesVote++;
      }
      else if (vote.equals("no"))
      {
        noVote++;
      }
      else
      {
        throw new Exception("Invalid or null selection");
      }


//       Initialize the bean userID property from the parameters
      pollUpdateBean.setUserID( userID );

//       Initialize the bean password property from the parameters
      pollUpdateBean.setPassword( password );
      
//       Initialize the bean URL property from the parameters
      pollUpdateBean.setURL( URL );

//       Initialize the bean driver property from the parameters
      pollUpdateBean.setDriver( driver );

//       Initialize the bean datasource property from the parameters
      pollUpdateBean.setDataSourceName( dataSourceName );

//       Initialize the bean noVote property from the parameters
      pollUpdateBean.setPollId( pollId );
      
//       Initialize the bean yesVote property from the parameters
      pollUpdateBean.setYesVote( String.valueOf(yesVote) );
      
//       Initialize the bean noVote property from the parameters
      pollUpdateBean.setNoVote( String.valueOf(noVote) );

      pollUpdateBean.execute();

      
//       Call the output page. If the output page is not passed
//       as part of the URL, the default page is called.
      callPage(getPageNameFromRequest(request), request, response);
    }

    catch (Exception theException)
    {
      handleError(request, response, theException);
    }
  }

}
