#!/bin/sh

DESTARG=null
DESTPORTARG=null

QUALIFYNAMES=%!%com.ibm.servlet.engine.webapp.AdminClientServlet.qualifyHomeNames%!%
AUTODEST=%!%com.ibm.servlet.engine.webapp.AdminClientServlet.host%!%                

if [ $# -eq 0 ]
then
 DEBUGOPTS=
elif [ $1 = debug ]
then
 DEBUGOPTS='-traceString "com.ibm.*=all=enabled" '
 if [ $# -eq 2 ]
 then
  DESTARG=$2
 elif [ $# -eq 3 ]
 then
  DESTARG=$2
  DESTPORTARG=$3
 fi
else
 DEBUGOPTS=
 if [ $# -eq 1 ]
 then
  DESTARG=$1
 elif [ $# -eq 2 ]
 then
  DESTARG=$1
  DESTPORTARG=$2
 fi
fi

if [ "${DESTARG}" = "null" ]
then
 if [ "${AUTODEST}" = "" ]
 then
  DESTARG=null
 else
  DESTARG=${AUTODEST}
 fi
fi           

if [ "${DESTARG}" = "null" ]
then
 echo 'No remote host or port argument specified. This host and port 900 will be used.'
 echo 'This command may be issued as: adminclient <host address <port number>>'
 DEST=
 DESTPORT=
elif [ "${DESTPORTARG}" = "null" ]
then
 DEST='-host '$DESTARG
 DESTPORT=
 echo 'Remote AdminServer '$DESTARG' will be accessed on the default port 900.'
else
 DEST='-host '$DESTARG
 DESTPORT='-port '$DESTPORTARG
 echo 'Remote AdminServer '$DESTARG' will be accessed on port '$DESTPORTARG'.'
fi

# setup the classpath
WAS_CP=../lib/ibmwebas.jar
WAS_CP=$WAS_CP:../properties
WAS_CP=$WAS_CP:../lib/chart.jar
WAS_CP=$WAS_CP:../lib/ejs.jar
WAS_CP=$WAS_CP:../lib/ujc.jar
WAS_CP=$WAS_CP:../lib/repository.jar
WAS_CP=$WAS_CP:../lib/admin.jar
WAS_CP=$WAS_CP:../lib/servlet.jar
WAS_CP=$WAS_CP:../lib/servletconsole.jar
WAS_CP=$WAS_CP:../lib/tasks.jar
WAS_CP=$WAS_CP:../lib/console.jar
WAS_CP=$WAS_CP:../lib/vaprt.jar
WAS_CP=$WAS_CP:../lib/sslight.jar
WAS_CP=$WAS_CP:../lib/xml4j.jar
WAS_CP=$WAS_CP:../web/help
export CLASSPATH=$WAS_CP

SEC_PROPS=
SEC_PROPS=$SEC_PROPS' -Dcom.ibm.CORBA.securityEnabled=true'
SEC_PROPS=$SEC_PROPS' -Dcom.ibm.CORBA.loginSource=prompt'
SEC_PROPS=$SEC_PROPS' -Dcom.ibm.CORBA.loginTimeout=30'
SEC_PROPS=$SEC_PROPS' -Dcom.ibm.CORBA.loginUserid='
SEC_PROPS=$SEC_PROPS' -Dcom.ibm.CORBA.loginPassword='
SEC_PROPS=$SEC_PROPS' -Dcom.ibm.CORBA.keytabFileName='
SEC_PROPS=$SEC_PROPS' -Dcom.ibm.CORBA.SSLTypeIClientAssociationEnabled=true'
SEC_PROPS=$SEC_PROPS' -Dcom.ibm.CORBA.SSLTypeIServerAssociationEnabled=true'
SEC_PROPS=$SEC_PROPS' -Dcom.ibm.CORBA.LTPAClientAssociationEnabled=false'
SEC_PROPS=$SEC_PROPS' -Dcom.ibm.CORBA.LTPAServerAssociationEnabled=true'
SEC_PROPS=$SEC_PROPS' -Dcom.ibm.CORBA.authenticationTarget=LocalOS'
SEC_PROPS=$SEC_PROPS' -Dcom.ibm.CORBA.SSLKeyRing=com.ibm.websphere.DummyKeyring'
SEC_PROPS=$SEC_PROPS' -Dcom.ibm.CORBA.SSLKeyRingPassword=WebAS'
SEC_PROPS=$SEC_PROPS' -Dcom.ibm.CORBA.SSLServerKeyRing=com.ibm.websphere.DummyKeyring'
SEC_PROPS=$SEC_PROPS' -Dcom.ibm.CORBA.SSLServerKeyRingPassword=WebAS'
SEC_PROPS=$SEC_PROPS' -Dcom.ibm.CORBA.SSLV3SessionTimeout=9600'
SEC_PROPS=$SEC_PROPS' -Dcom.ibm.CORBA.standardPerformQOPModels=confidentiality'
SEC_PROPS=$SEC_PROPS' -Dcom.ibm.CORBA.standardClaimQOPModels=integrity'
SEC_PROPS=$SEC_PROPS' -Dcom.ibm.CORBA.bootstrapRepositoryLocation=none'         


LP=$LP:$WAS_HOME/bin
LP=$LP:$SHLIB_PATH
export SHLIB_PATH=$LP

# Set the ulimit
LIMIT=`ulimit -a | grep nofiles | cut -f 2 -d " "`
if [ "${LIMIT}" != "unlimited" ]
then
    ulimit -n 1024
fi

if [ "${JAVA_HOME}" = "" ]
then
 echo "The JAVA_HOME environment variable must be set to the path for correct version of Java"
fi          


$JAVA_HOME/bin/java -mx50331648 -ms16m $CLIENTSAS -Dcom.ibm.CORBA.principalName=`hostname`/AdminClient -Dserver.root=$WAS_HOME com.ibm.ejs.sm.client.ui.EJSConsole $DEST $DESTPORT $DEBUGOPTS $QUALIFYNAMES
