@echo off
echo OFF
REM IBM WebSphere Application Server V3.5.6 Standard Fixpack
set COPYCMD=/Y

set SILENT_INSTALL=false
set IGNORE_ERRORS=false
IF  (%1) == ()                              goto check_was_off
IF  (%1) == (-silent) IF (%2) == (-ignore)  goto set_silent_and_ignore
IF  (%1) == (-ignore) IF (%2) == (-silent)  goto set_silent_and_ignore
IF  (%1) == (-silent)                       goto set_silent_true
IF  (%1) == (-ignore)                       goto ignore_errors

REM Any other flags are incorrect.
:silent_usage
echo.
echo Usage:To run the silent ptf install, please type: install.bat -silent
echo       Also, please have these variables set in the shell:
echo       WAS_HOME : Set this to the WebSphere root directory.
echo                 (eg: c:\WebSphere\AppServer)
echo       IHS_INSTALL : Set this to "true" or "false" regarding upgrading the IBM HTTP Server.
echo       IHS_HOME : Set this to the IBM HTTP Server root directory if upgrading IHS. 
echo                 (eg: c:\Program Files\IBM HTTP Server)
echo       DOC_ROOT : Set this to the webserver's document root, or leave blank for no samples update.
echo                 (eg: c:\Program Files\IBM HTTP Server\htdocs)
echo       IPLANET_HOME : Set this to the configuration directory of the iPlanet 6.0 webserver (if it is installed).
echo                     (eg: c:\iPlanet\Servers\https-<hostname>\config)
echo                      if you do not have iPlanet 6.0.x installed then leave the path empty.
echo.
goto exit

:set_silent_true
set SILENT_INSTALL=true
goto check_silent_vars

:ignore_errors
set IGNORE_ERRORS=true
echo.
echo You have chosen to let the ptf install ignore the errors thrown during 
echo the install.  It is recommended to use this option (-ignore) only when
echo the ptf will be installed on a machine that does not have a full 
echo WebSphere installation (example: IHS and plugin only configuration).
echo.
goto check_was_off

:set_silent_and_ignore
set SILENT_INSTALL=true
set IGNORE_ERRORS=true
goto check_silent_vars

:check_was_off
GetInput F_RES "Please make sure WebSphere is shut down, then press return. " ~wasshut.bat
call ~wasshut.bat
del ~wasshut.bat

:check_was_home
if (%WAS_HOME%) == () goto prompt_was_home
set F_WAS_HOME=%WAS_HOME%

if (%SILENT_INSTALL%)==(true)  goto verify_was_home

if not (%WAS_HOME%)== () goto change_was_home
goto verify_was_home


:change_was_home
if (%SILENT_INSTALL%)==(true)  goto silent_usage
REM Get WAS Install Dir
echo Current WASHOME %WAS_HOME%
GetInput WAS_CONFIRM "Do you want to change the WAS HOME directory?(Yes/No)" ~confirm.bat
call ~confirm.bat
del ~confirm.bat
if (%WAS_CONFIRM%) == (y) goto prompt_was_home
if (%WAS_CONFIRM%) == (Y) goto prompt_was_home
if (%WAS_CONFIRM%) == (yes) goto prompt_was_home
if (%WAS_CONFIRM%) == (Yes) goto prompt_was_home
if (%WAS_CONFIRM%) == (YES) goto prompt_was_home
goto verify_was_home


:prompt_was_home
if (%SILENT_INSTALL%)==(true)  goto silent_usage
REM Get WAS Install Dir
GetInput F_WAS_HOME "Enter the directory where the IBM WebSphere Application Server is installed: " ~washome.bat
call ~washome.bat
del ~washome.bat

:verify_was_home
IF  NOT EXIST  %F_WAS_HOME%\properties\com\ibm\websphere\product.xml   goto bad_was_home

set F_JDK_HOME=%F_WAS_HOME%\jdk

echo WASHOME %F_WAS_HOME%

echo JDKHOME %F_JDK_HOME%

copy GetInput.exe %F_WAS_HOME%

:check_java_home
if exist %F_JDK_HOME%\bin\java.exe  goto run_fixpack

:prompt_java_home
GetInput F_JDK_HOME "Enter the directory where the IBM JDK 1.2.2 is installed: " ~jdkhome.bat
call ~jdkhome.bat
del ~jdkhome.bat
goto check_java_home

:run_fixpack
echo "Installing the WebSphere Application Server Standard Edition 3.5 PTF 6"
%F_JDK_HOME%\bin\java -jar was35_std_ptf_6.jar -target %F_WAS_HOME% -backupJar %F_WAS_HOME%\was35_ptf_6_backup.jar -log %F_WAS_HOME%/logs/was35_ptf_6.log

%F_JDK_HOME%\bin\java -classpath %F_WAS_HOME% IPlanet6Support %F_WAS_HOME% %SILENT_INSTALL% %IPLANET_HOME%
del %F_WAS_HOME%\IPlanet6Support.class

IF (%IGNORE_ERRORS%) == (false) IF (%errorlevel%) NEQ (0) goto was_ptf_error


:upgrade_jdk
echo Upgrading IBM JDK 1.2.2
xcopy %F_JDK_HOME%\* %F_WAS_HOME%\java_ptf_6 /e/q/i
%F_JDK_HOME%\bin\java -jar jdk_ptf_6.jar -target %F_WAS_HOME%\java_ptf_6 -backupJar %F_WAS_HOME%\jdk_ptf_6_backup.jar -log %F_WAS_HOME%/logs/jdk_ptf_6.log -SkipVer
if (%errorlevel%) NEQ (0) goto jdk_ptf_error
pause
xcopy %F_WAS_HOME%\java_ptf_6\* %F_JDK_HOME% /e/q/i
rmdir %F_WAS_HOME%\java_ptf_6 /S/Q


:prompt_ihs
if (%SILENT_INSTALL%) == (true) goto verify_ihs
REM Install IHS?
echo WARNING: If you install IBM HTTP Server PTF, you may not be able to uninstall it cleanly. The GSkit package will not be uninstalled.
GetInput F_IHS_YN "Do you wish to upgrade the IBM HTTP Server 1.3.12:(Yes/No) " ~ihsprompt.bat
call ~ihsprompt.bat
del ~ihsprompt.bat
if (%F_IHS_YN%) == (yes) goto check_for_ihs
if (%F_IHS_YN%) == (Yes) goto check_for_ihs
if (%F_IHS_YN%) == (YES) goto check_for_ihs
if (%F_IHS_YN%) == (y) goto check_for_ihs
if (%F_IHS_YN%) == (Y) goto check_for_ihs
goto prompt_samples

:check_for_ihs
REM Enter IHS home path
echo EXAMPLE: C:\IBM HTTP Server
GetInput F_IHS_HOME "Enter the directory where the IBM HTTP Server 1.3.12 is installed: " ~ihshome.bat
call ~ihshome.bat
del ~ihshome.bat
if "%F_IHS_HOME%" == "" goto prompt_samples

:verify_ihs
REM CHeck silent install variable IHS_INSTALL first.  If equal blank, regular install continues.
if (%IHS_INSTALL%) == (false) goto prompt_samples
if (%IHS_INSTALL%) == (true)  set F_IHS_HOME=%IHS_HOME%
if (%IHS_INSTALL%) == (true)  goto upgrade_ihs
if exist "%F_IHS_HOME%\conf\httpd.conf" goto upgrade_ihs
echo Unable to find IBM HTTP Server Application in specified path: %F_IHS_HOME%
goto prompt_ihs

:upgrade_ihs
echo Upgrading IHS
REM defect 110215 updating to ihs ptf 5 
%F_JDK_HOME%\bin\java -jar ihs_ptf_6.jar -target "%F_IHS_HOME%" -backupJar %F_WAS_HOME%\ihs_ptf_6_backup.jar -log %F_WAS_HOME%/logs/ihs_ptf_6.log -SkipVer
if (%errorlevel%) NEQ (0) goto ihs_ptf_error
REM update system directory
xcopy "%F_IHS_HOME%\system32\*" %windir%\system32 /s
REM install GSKIT
"%F_IHS_HOME%\skit\setup" GSkit4 "%SystemDrive%\Program Files" -s -f2.\gskit4.log
if (%errorlevel%) NEQ (0) goto ihs_ptf_error


REM Check for silent install of samples
:prompt_samples
IF (%SILENT_SAMPLES%) == (false) goto complete
IF (%SILENT_SAMPLES%) == (true)  set F_DOC_ROOT=%DOC_ROOT%
IF (%SILENT_SAMPLES%) == (true)  goto install_samples

REM upgrade the Samples in the doc root
	GetInput F_CONFIRM "Do you wish to upgrade the WebSphere Application Server samples?(Yes/No)" ~confirm.bat
	call ~confirm.bat
	del ~confirm.bat
	if (%F_CONFIRM%) == (y) goto samples
	if (%F_CONFIRM%) == (Y) goto samples
	if (%F_CONFIRM%) == (yes) goto samples
	if (%F_CONFIRM%) == (Yes) goto samples
	if (%F_CONFIRM%) == (YES) goto samples
	goto complete
:samples
   echo off
   echo In order to update the WebSphere Application Server Samples
   echo the currently configured WebServer's doc root must be specified
   echo Eg. C:\IBM HTTP Server\htdocs
   GetInput F_DOC_ROOT "Please enter your webserver's doc root path:" ~docroot.bat
	call ~docroot.bat
	del ~docroot.bat
	echo %F_DOC_ROOT%
	GetInput F_CONFIRM "Is this correct?(Yes/No)" ~confirm.bat
	call ~confirm.bat
	del ~confirm.bat
	if (%F_CONFIRM%) == (n) goto samples
	if (%F_CONFIRM%) == (N) goto samples
	if (%F_CONFIRM%) == (no) goto samples
	if (%F_CONFIRM%) == (No) goto samples
	if (%F_CONFIRM%) == (NO) goto samples

:install_samples
	xcopy %F_WAS_HOME%\WSsamples "%F_DOC_ROOT%\WSsamples" /e/q/i
	xcopy %F_WAS_HOME%\WSsamplesIDB "%F_DOC_ROOT%\WSsamplesIDB" /e/q/i
	xcopy %F_WAS_HOME%\theme "%F_DOC_ROOT%\theme" /e/q/i

goto complete

:bad_was_home
echo Can not find WebSphere Application Server in %F_WAS_HOME%
echo Install aborted
goto exit


:check_silent_vars
IF NOT EXIST %WAS_HOME%\properties\com\ibm\websphere\product.xml echo Invalid WAS_HOME set.
IF NOT EXIST %WAS_HOME%\properties\com\ibm\websphere\product.xml goto silent_usage

set SILENT_SAMPLES=true
IF NOT EXIST "%DOC_ROOT%"  set SILENT_SAMPLES=false

IF (%IHS_INSTALL%) == () echo IHS_INSTALL is not set to true or false.
IF (%IHS_INSTALL%) == () goto silent_usage

IF (%IHS_INSTALL%) NEQ (false) goto ihs_silent_true
goto check_was_home


:ihs_silent_true
IF (%IHS_INSTALL%) NEQ (true) echo IHS_INSTALL is not set correctly to true or false.
IF (%IHS_INSTALL%) NEQ (true) goto silent_usage

IF NOT EXIST %IHS_HOME%\conf\httpd.conf  echo IHS_INSTALL=true and IHS_HOME is not set correctly.
IF NOT EXIST %IHS_HOME%\conf\httpd.conf  goto silent_usage
goto check_was_home


:was_ptf_error
echo Either the user has chosen to exit, or there was an error during the WebSphere PTF upgrade.
echo In case of error, run uninstall_ptf_#.bat to back out the changes.
echo The PTF upgrade will end now.
goto exit

:jdk_ptf_error
echo Either the user has chosen to exit, or there was an error during the JDK PTF upgrade.
echo In case of error, run uninstall_ptf_#.bat to back out the changes.
echo The PTF upgrade will end now.
goto exit

:ihs_ptf_error
echo Either the user has chosen to exit, or there was an error during the IBM HTTP Server PTF upgrade.
echo In case of error, run uninstall_ptf_#.bat to back out the changes.
echo The PTF upgrade will end now.
goto exit

:complete
echo IBM WebSphere Application Server V3.5.6 Standard Fixpack install complete

:exit
